'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _style = require('styled-jsx/style');

var _style2 = _interopRequireDefault(_style);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _defaultStyles = require('./defaultStyles');

var _ModalDialog = require('./ModalDialog');

var _ModalDialog2 = _interopRequireDefault(_ModalDialog);

var _RTGFade = require('./RTGFade');

var _RTGFade2 = _interopRequireDefault(_RTGFade);

var _Step = require('./Step');

var _Step2 = _interopRequireDefault(_Step);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MultiplePageModal = function MultiplePageModal(_ref) {
  var pageNavigationButtonsAreDisabled = _ref.pageNavigationButtonsAreDisabled,
      renderTrigger = _ref.renderTrigger,
      _ref$onMount = _ref.onMount,
      onMount = _ref$onMount === undefined ? function () {} : _ref$onMount,
      _ref$onUnmount = _ref.onUnmount,
      onUnmount = _ref$onUnmount === undefined ? function () {} : _ref$onUnmount,
      closeModalButtonIsRendered = _ref.closeModalButtonIsRendered,
      pages = _ref.pages,
      steps = _ref.steps,
      _ref$stepsStyle = _ref.stepsStyle,
      stepsStyle = _ref$stepsStyle === undefined ? {
    shared: 'height: 6rem; padding: 1rem 2rem;',
    inactive: {
      background: '#fff'
    },
    active: {
      background: '#eee'
    }
  } : _ref$stepsStyle,
      currentPage = _ref.currentPage,
      goToNextPage = _ref.goToNextPage,
      goToPreviousPage = _ref.goToPreviousPage,
      setCurrentPageTo = _ref.setCurrentPageTo,
      modalIsOpen = _ref.modalIsOpen,
      toggleModal = _ref.toggleModal,
      isTesting = _ref.isTesting,
      containerPropsOverride = _ref.containerPropsOverride,
      containerPropsAppend = _ref.containerPropsAppend,
      _ref$backgroundPropsO = _ref.backgroundPropsOverride,
      backgroundPropsOverride = _ref$backgroundPropsO === undefined ? {} : _ref$backgroundPropsO,
      _ref$backgroundPropsA = _ref.backgroundPropsAppend,
      backgroundPropsAppend = _ref$backgroundPropsA === undefined ? {} : _ref$backgroundPropsA,
      renderNextButton = _ref.renderNextButton,
      renderBackButton = _ref.renderBackButton;

  var renderPageNavigationButtons = function renderPageNavigationButtons(_ref2) {
    var currentPage = _ref2.currentPage,
        length = _ref2.length,
        getButtonProps = _ref2.getButtonProps;

    var renderNext = function renderNext() {
      return renderNextButton({
        getButtonProps: getButtonProps,
        disabled: pageNavigationButtonsAreDisabled,
        goToNextPage: goToNextPage
      });
    };
    var renderBack = function renderBack() {
      return renderBackButton({ getButtonProps: getButtonProps, goToPreviousPage: goToPreviousPage });
    };
    if (currentPage === 0) {
      return renderNext();
    }
    if (currentPage === length - 1) {
      return renderBack();
    } else {
      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        renderBack(),
        renderNext()
      );
    }
  };

  var renderSteps = function renderSteps(currentPageNumber, steps) {
    return _react2.default.createElement(
      'div',
      {
        className: _style2.default.dynamic([['610792458', [300 * steps.length, 300 * steps.length, 300 * steps.length, 300 * steps.length, 300 * steps.length, 300 * steps.length, stepsStyle.shared, stepsStyle.active.background, stepsStyle.inactive.background, stepsStyle.active.background, stepsStyle.inactive.background]]]) + ' ' + 'multiplepagemodal__steps'
      },
      _react2.default.createElement(_style2.default, {
        styleId: '610792458',
        css: '.multiplepagemodal__steps{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;}@media screen and (max-width:' + 300 * steps.length + 'px){.multiplepagemodal__steps{-webkit-flex-direction:column;-ms-flex-direction:column;flex-direction:column;}}@media screen and (min-width:' + 300 * steps.length + 'px){.multiplepagemodal__steps .step__container{-webkit-flex-basis:30rem;-ms-flex-preferred-size:30rem;flex-basis:30rem;}}.step__container{' + stepsStyle.shared + ' position:relative;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;cursor:pointer;}.step__container--inactive--last--disabled{border-width:0px 0px 0px 0px;cursor:default;}.step__container--active--notlast--enabled{background:' + stepsStyle.active.background + ';border-style:solid;border-color:#dddddd;}@media screen and (max-width:' + 300 * steps.length + 'px){.step__container--active--notlast--enabled{border-width:0 0 1px 0px;}}@media screen and (min-width:' + 300 * steps.length + 'px){.step__container--active--notlast--enabled{border-width:0 1px 0px 0;}}.step__container--active--notlast--enabled::after{background:' + stepsStyle.active.background + ';display:block;position:absolute;z-index:2;content:\'\';width:1rem;height:1rem;border-style:solid;border-color:#dddddd;-webkit-transform:translateY(-50%) translateX(50%) rotate(-45deg);-webkit-transform:translateY(-50%) translateX(50%) rotate(-45deg);-ms-transform:translateY(-50%) translateX(50%) rotate(-45deg);transform:translateY(-50%) translateX(50%) rotate(-45deg);}@media screen and (max-width:' + 300 * steps.length + 'px){.step__container--active--notlast--enabled::after{bottom:-15%;right:50%;border-width:0 0 1px 1px;}}@media screen and (min-width:' + 300 * steps.length + 'px){.step__container--active--notlast--enabled::after{top:50%;right:0;border-width:0 1px 1px 0;}}.step__container--inactive--notlast--enabled{background:' + stepsStyle.inactive.background + ';border-style:solid;border-color:#dddddd;}@media screen and (max-width:' + 300 * steps.length + 'px){.step__container--inactive--notlast--enabled{border-width:0 0 1px 0px;}}@media screen and (min-width:' + 300 * steps.length + 'px){.step__container--inactive--notlast--enabled{border-width:0 1px 0px 0;}}.step__container--inactive--notlast--enabled::after{background:' + stepsStyle.inactive.background + ';display:block;position:absolute;z-index:2;content:\'\';width:1rem;height:1rem;border-style:solid;border-color:#dddddd;-webkit-transform:translateY(-50%) translateX(50%) rotate(-45deg);-webkit-transform:translateY(-50%) translateX(50%) rotate(-45deg);-ms-transform:translateY(-50%) translateX(50%) rotate(-45deg);transform:translateY(-50%) translateX(50%) rotate(-45deg);}@media screen and (max-width:' + 300 * steps.length + 'px){.step__container--inactive--notlast--enabled::after{bottom:-15%;right:50%;border-width:0 0 1px 1px;}}@media screen and (min-width:' + 300 * steps.length + 'px){.step__container--inactive--notlast--enabled::after{top:50%;right:0;border-width:0 1px 1px 0;}}.step__container--active--last--enabled{background:' + stepsStyle.active.background + ';}.step__container--inactive--last--enabled{background:' + stepsStyle.inactive.background + ';}',
        dynamic: [300 * steps.length, 300 * steps.length, 300 * steps.length, 300 * steps.length, 300 * steps.length, 300 * steps.length, stepsStyle.shared, stepsStyle.active.background, stepsStyle.inactive.background, stepsStyle.active.background, stepsStyle.inactive.background]
      }),
      steps.map(function (_ref3, stepNumber) {
        var renderStep = _ref3.renderStep;
        return _react2.default.createElement(_Step2.default, {
          onClick: function onClick() {
            return setCurrentPageTo(stepNumber);
          },
          key: stepNumber,
          isActive: currentPageNumber === stepNumber,
          isDisabled: stepNumber > currentPageNumber && pageNavigationButtonsAreDisabled,
          isComplete: currentPageNumber > stepNumber,
          isLast: stepNumber === steps.length - 1,
          renderStep: renderStep
        });
      })
    );
  };
  var getTriggerProps = function getTriggerProps() {
    var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var _onClick = _ref4.onClick,
        className = _ref4.className,
        props = (0, _objectWithoutProperties3.default)(_ref4, ['onClick', 'className']);
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        toggleModal();
        _onClick && _onClick.apply(undefined, [e].concat(args));
      },
      className: className ? 'actionmodal__trigger ' + className : 'actionmodal__trigger'

    }, props);
  };
  return _react2.default.createElement(
    _react2.default.Fragment,
    null,
    renderTrigger && renderTrigger({ modalIsOpen: modalIsOpen, toggleModal: toggleModal, getTriggerProps: getTriggerProps }),
    _react2.default.createElement(
      _RTGFade2.default,
      (0, _extends3.default)({
        duration: 100,
        className: backgroundPropsAppend.className ? 'modal__background ' + backgroundPropsAppend.className : 'modal__background',
        style: isTesting ? null : backgroundPropsAppend.style ? (0, _extends3.default)({}, _defaultStyles.defaultStyles.background, backgroundPropsAppend.style) : _defaultStyles.defaultStyles.background,
        'in': isTesting ? true : modalIsOpen,
        onClick: toggleModal
      }, backgroundPropsOverride),
      pages.map(function (page, i) {
        return currentPage === i && _react2.default.createElement(_ModalDialog2.default, {
          onMount: onMount,
          onUnmount: onUnmount,
          key: currentPage,
          containerPropsOverride: containerPropsOverride,
          containerPropsAppend: containerPropsAppend,
          closeModalButtonIsRendered: closeModalButtonIsRendered,
          renderHeader: function renderHeader(_ref5) {
            var getHeaderProps = _ref5.getHeaderProps;
            return page.renderHeader ? page.renderHeader({ getHeaderProps: getHeaderProps, renderSteps: renderSteps(i, steps) }) : steps ? _react2.default.createElement(
              'div',
              getHeaderProps(),
              renderSteps(i, steps)
            ) : null;
          },
          renderButtons: function renderButtons(_ref6) {
            var getButtonProps = _ref6.getButtonProps,
                getButtonsProps = _ref6.getButtonsProps;
            return page.renderButtons ? page.renderButtons({
              getButtonProps: getButtonProps,
              getButtonsProps: getButtonsProps,
              renderPageNavigationButtons: renderPageNavigationButtons({
                currentPage: i,
                length: pages.length,
                getButtonProps: getButtonProps
              })
            }) : _react2.default.createElement(
              'div',
              (0, _extends3.default)({}, getButtonsProps()),
              renderPageNavigationButtons({
                currentPage: i,
                length: pages.length,
                getButtonProps: getButtonProps
              })
            );
          },
          renderBody: function renderBody(_ref7) {
            var getBodyProps = _ref7.getBodyProps;
            return page.renderBody ? page.renderBody({ getBodyProps: getBodyProps, setCurrentPageTo: setCurrentPageTo, toggleModal: toggleModal }) : _react2.default.createElement(
              'div',
              (0, _extends3.default)({}, getBodyProps()),
              page.renderBody({ setCurrentPageTo: setCurrentPageTo, toggleModal: toggleModal })
            );
          },
          toggleModal: toggleModal
        });
      })
    )
  );
}; //write toggleModal inside recompose handler
// adjust styling for 2+ steps


var enhance = (0, _recompose.compose)((0, _recompose.withState)('modalIsOpen', 'setModalIsOpenTo', false), (0, _recompose.withState)('currentPage', 'setCurrentPageTo', 0), (0, _recompose.withHandlers)({
  toggleModal: function toggleModal(_ref8) {
    var setModalIsOpenTo = _ref8.setModalIsOpenTo;
    return function () {
      setModalIsOpenTo(function (x) {
        console.log('toggle modal to ' + x);
        return !x;
      });
    };
  },

  goToNextPage: function goToNextPage(_ref9) {
    var setCurrentPageTo = _ref9.setCurrentPageTo,
        pages = _ref9.pages;
    return function () {
      setCurrentPageTo(function (n) {
        return n === pages.length - 1 ? n : n + 1;
      });
    };
  },
  goToPreviousPage: function goToPreviousPage(_ref10) {
    var setCurrentPageTo = _ref10.setCurrentPageTo;
    return function () {
      setCurrentPageTo(function (n) {
        return n === 0 ? n : n - 1;
      });
    };
  }
}), (0, _recompose.setPropTypes)({
  pages: _propTypes2.default.array.isRequired,
  steps: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    renderStep: _propTypes2.default.func.isRequired
  })).isRequired,
  renderTrigger: _propTypes2.default.func.isRequired,
  pageNavigationButtonsAreDisabled: _propTypes2.default.bool,
  closeModalButtonIsRendered: _propTypes2.default.bool,

  modalIsOpen: _propTypes2.default.bool.isRequired,
  currentPage: _propTypes2.default.number.isRequired,
  toggleModal: _propTypes2.default.func.isRequired,
  setCurrentPageTo: _propTypes2.default.func.isRequired,
  goToNextPage: _propTypes2.default.func.isRequired,
  goToPreviousPage: _propTypes2.default.func.isRequired
}));

MultiplePageModal.defaultProps = {
  pageNavigationButtonsAreDisabled: false,
  renderNextButton: function renderNextButton(_ref11) {
    var getButtonProps = _ref11.getButtonProps,
        goToNextPage = _ref11.goToNextPage,
        disabled = _ref11.disabled;
    return _react2.default.createElement(
      'button',
      (0, _extends3.default)({}, getButtonProps({ onClick: goToNextPage }), { disabled: disabled }),
      'NEXT'
    );
  },
  renderBackButton: function renderBackButton(_ref12) {
    var getButtonProps = _ref12.getButtonProps,
        goToPreviousPage = _ref12.goToPreviousPage;
    return _react2.default.createElement(
      'button',
      (0, _extends3.default)({}, getButtonProps({ onClick: goToPreviousPage })),
      'BACK'
    );
  }
};

exports.default = enhance(MultiplePageModal);