'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.SelectMany = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _helperFunctions = require('./helperFunctions');

var _DropdownPopover = require('./DropdownPopover');

var _DropdownPopover2 = _interopRequireDefault(_DropdownPopover);

var _defaultStyles = require('./defaultStyles');

var defaultStyles = _interopRequireWildcard(_defaultStyles);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//import { Button } from './Button'

var Option = function Option(_ref) {
	var className = _ref.className,
	    isActive = _ref.isActive,
	    value = _ref.value,
	    label = _ref.label,
	    children = _ref.children,
	    currentValue = _ref.currentValue,
	    pivotFrom = _ref.pivotFrom,
	    addToCurrent = _ref.addToCurrent,
	    removeFromCurrent = _ref.removeFromCurrent,
	    onChange = _ref.onChange,
	    sortingFunction = _ref.sortingFunction,
	    styleAppend = _ref.styleAppend,
	    styleOverride = _ref.styleOverride;
	return _react2.default.createElement(
		'div',
		{
			onClick: function () {
				var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(e) {
					return _regenerator2.default.wrap(function _callee$(_context) {
						while (1) {
							switch (_context.prev = _context.next) {
								case 0:
									if (currentValue.map(function (v) {
										return v.value;
									}).includes(value)) {
										removeFromCurrent(value);
										onChange(currentValue.filter(function (x) {
											return x.value !== value;
										}));
									} else {
										addToCurrent({ value: value, label: label });
										if (sortingFunction) {
											onChange([].concat((0, _toConsumableArray3.default)(currentValue), [{
												value: value,
												label: label
											}]).sort(sortingFunction));
										} else {
											onChange([].concat((0, _toConsumableArray3.default)(currentValue), [{ value: value, label: label }]));
										}
									}

								case 1:
								case 'end':
									return _context.stop();
							}
						}
					}, _callee, undefined);
				}));

				function onClick(_x) {
					return _ref2.apply(this, arguments);
				}

				return onClick;
			}(),
			className: (0, _helperFunctions.flippyClass)(isActive(value), 'selectmany__option', 'active', 'inactive') + ' ' + (className ? (0, _helperFunctions.flippyClass)(isActive(value), className, 'active', 'inactive') : '')
			//style: styleAppend
			//	? { ...style, ...styleAppend }
			//	: styleOverride ? styleOverride : defaultStyles.selectMany.option,
		},
		children
	);
};

var SelectMany = function SelectMany(_ref3) {
	var sortingFunction = _ref3.sortingFunction,
	    shouldToggleOnHover = _ref3.shouldToggleOnHover,
	    transitionOptions = _ref3.transitionOptions,
	    onChange = _ref3.onChange,
	    triggerX = _ref3.triggerX,
	    basewidth = _ref3.basewidth,
	    buttonProps = _ref3.buttonProps,
	    children = _ref3.children,
	    clearCurrent = _ref3.clearCurrent,
	    className = _ref3.className,
	    pivotFrom = _ref3.pivotFrom,
	    _renderTrigger = _ref3.renderTrigger,
	    currentValue = _ref3.currentValue,
	    addToCurrent = _ref3.addToCurrent,
	    removeFromCurrent = _ref3.removeFromCurrent;

	var getChildProps = function getChildProps() {
		var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		var className = _ref4.className,
		    style = _ref4.style,
		    _onClick = _ref4.onClick,
		    value = _ref4.value,
		    props = (0, _objectWithoutProperties3.default)(_ref4, ['className', 'style', 'onClick', 'value']);

		var isActive = function isActive(value) {
			return currentValue.some(function (cV) {
				return cV.value === value.value;
			});
		};

		return (0, _extends3.default)({
			onClick: function onClick(e) {
				for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
					args[_key - 1] = arguments[_key];
				}

				e.stopPropagation();
				console.log(currentValue, value);
				if (currentValue.map(function (v) {
					return v.value;
				}).includes(value.value)) {
					removeFromCurrent(value);
					onChange(currentValue.filter(function (x) {
						return x.value !== value.value;
					}));
				} else {
					addToCurrent(value);
					if (sortingFunction) {
						onChange([].concat((0, _toConsumableArray3.default)(currentValue), [value]).sort(sortingFunction));
					} else {
						onChange([].concat((0, _toConsumableArray3.default)(currentValue), [value]));
					}
				}
				_onClick && _onClick.apply(undefined, [e].concat(args));
			},
			className: (0, _helperFunctions.flippyClass)(isActive(value), 'selectmany__option', 'active', 'inactive') + ' ' + (className ? (0, _helperFunctions.flippyClass)(isActive(value), className, 'active', 'inactive') : ''),
			style: style
		}, props);
	};
	var mappedChildren = _react2.default.Children.map(children, function (child) {
		return _react2.default.cloneElement(child, {
			sortingFunction: sortingFunction,
			currentValue: currentValue,
			className: className,
			onChange: onChange,
			isActive: function isActive(value) {
				console.log(currentValue, value);
				return currentValue.some(function (cV) {
					return cV.value === value;
				});
			},
			addToCurrent: addToCurrent,
			removeFromCurrent: removeFromCurrent
		});
	});

	return _react2.default.createElement(
		_DropdownPopover2.default,
		{
			pivotFrom: pivotFrom,
			transitionOptions: transitionOptions,
			shouldToggleOnHover: shouldToggleOnHover
			//renderTrigger={({ isOn, getTriggerProps }) => (
			//	<Button {...buttonProps} {...getTriggerProps({ isOn })}>
			//		{<div>{currentValue.map((v) => v.label).join(`, `)}</div>}
			//		{isOn ? <img src={`/static/expandless.svg`} /> : <img src={`/static/expandmore.svg`} />}
			//	</Button>
			//)}
			, triggerX: triggerX,
			basewidth: basewidth,
			renderTrigger: function renderTrigger(_ref5) {
				var isOn = _ref5.isOn,
				    _getTriggerProps = _ref5.getTriggerProps;
				return _renderTrigger ? _renderTrigger({
					activeChildren: currentValue.map(function (v) {
						return v.label;
					}).join(', '),
					isOn: isOn,
					getTriggerProps: function getTriggerProps() {
						var _ref6 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

						var className = _ref6.className,
						    style = _ref6.style,
						    props = (0, _objectWithoutProperties3.default)(_ref6, ['className', 'style']);
						return _getTriggerProps((0, _extends3.default)({
							className: 'selectmany__trigger ' + (className ? className : '')
						}, props));
					}
				}) : _react2.default.createElement(
					'button',
					_getTriggerProps(),
					_react2.default.createElement(
						'div',
						null,
						currentValue.map(function (v) {
							return v.label;
						}).join(', ')
					),
					isOn ? _react2.default.createElement('img', { src: '/static/expandless.svg' }) : _react2.default.createElement('img', { src: '/static/expandmore.svg' })
				);
			},
			parentName: 'select'
		},
		function (_ref7) {
			var toggle = _ref7.toggle;
			return children({ getChildProps: getChildProps, toggle: toggle });
		}
	);
};

exports.SelectMany = SelectMany;
SelectMany.propTypes = {};
SelectMany.defaultProps = {
	buttonType: 'select--default'
};

var enhance = (0, _recompose.compose)(
//onlyUpdateForKeys(`children`),
(0, _recompose.setStatic)('Option', Option), (0, _recompose.withState)('currentValue', 'setCurrentValue', function (_ref8) {
	var _ref8$currentValue = _ref8.currentValue,
	    currentValue = _ref8$currentValue === undefined ? [] : _ref8$currentValue;
	return currentValue;
}), (0, _recompose.withHandlers)({
	addToCurrent: function addToCurrent(_ref9) {
		var setCurrentValue = _ref9.setCurrentValue,
		    sortingFunction = _ref9.sortingFunction;
		return function (value) {
			console.log(sortingFunction);
			if (sortingFunction) {
				setCurrentValue(function (x) {
					return [].concat((0, _toConsumableArray3.default)(x), [value]).sort(sortingFunction);
				});
			} else {
				setCurrentValue(function (x) {
					return [].concat((0, _toConsumableArray3.default)(x), [value]);
				});
			}
		};
	},
	removeFromCurrent: function removeFromCurrent(_ref10) {
		var setCurrentValue = _ref10.setCurrentValue;
		return function (value) {
			return setCurrentValue(function (x) {
				return x.filter(function (v) {
					return v.value !== value.value;
				});
			});
		};
	},
	clearCurrent: function clearCurrent(_ref11) {
		var setCurrentValue = _ref11.setCurrentValue;
		return function () {
			return setCurrentValue([]);
		};
	}
}));

exports.default = enhance(SelectMany);