'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _SignInForm = require('./SignInForm');

var _SignInForm2 = _interopRequireDefault(_SignInForm);

var _RegisterAccountModal = require('./RegisterAccountModal');

var _RegisterAccountModal2 = _interopRequireDefault(_RegisterAccountModal);

var _SinglePageModal = require('./SinglePageModal');

var _SinglePageModal2 = _interopRequireDefault(_SinglePageModal);

var _PasswordRecoveryModal = require('./PasswordRecoveryModal');

var _PasswordRecoveryModal2 = _interopRequireDefault(_PasswordRecoveryModal);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SignInModal = function SignInModal(_ref) {
  var onSignedIn = _ref.onSignedIn,
      handleSignInWithEmailAndPassword = _ref.handleSignInWithEmailAndPassword,
      handleCreateUserWithEmailAndPassword = _ref.handleCreateUserWithEmailAndPassword,
      handleSendPasswordResetEmail = _ref.handleSendPasswordResetEmail,
      handleSignInWithFacebook = _ref.handleSignInWithFacebook,
      handleSignInWithGoogle = _ref.handleSignInWithGoogle,
      labels = _ref.labels,
      props = (0, _objectWithoutProperties3.default)(_ref, ['onSignedIn', 'handleSignInWithEmailAndPassword', 'handleCreateUserWithEmailAndPassword', 'handleSendPasswordResetEmail', 'handleSignInWithFacebook', 'handleSignInWithGoogle', 'labels']);

  return _react2.default.createElement(_SinglePageModal2.default, (0, _extends3.default)({
    containerPropsAppend: { className: 'signinmodal__container' },
    dataTestId: 'signinmodal-container',
    renderTrigger: function renderTrigger(_ref2) {
      var getTriggerProps = _ref2.getTriggerProps;
      return _react2.default.createElement(
        _Button2.default,
        (0, _extends3.default)({}, getTriggerProps()),
        'Sign in'
      );
    },
    renderHeader: function renderHeader(_ref3) {
      var getHeaderProps = _ref3.getHeaderProps;
      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({}, getHeaderProps()),
        'Sign in header'
      );
    },
    renderBody: function renderBody(_ref4) {
      var getBodyProps = _ref4.getBodyProps;
      return _react2.default.createElement(
        'div',
        getBodyProps(),
        _react2.default.createElement(_SignInForm2.default, {
          callback: onSignedIn,
          handleSignInWithEmailAndPassword: handleSignInWithEmailAndPassword,
          labels: labels.signinform
        }),
        _react2.default.createElement(
          'div',
          { className: 'signinmodal__buttons--auxiliary' },
          _react2.default.createElement(_RegisterAccountModal2.default, { labels: labels.registeraccountmodal, handleCreateUserWithEmailAndPassword: handleCreateUserWithEmailAndPassword }),
          _react2.default.createElement(_PasswordRecoveryModal2.default, { labels: labels.passwordrecoverymodal, handleSendPasswordResetEmail: handleSendPasswordResetEmail })
        ),
        _react2.default.createElement(
          'div',
          { style: { display: 'flex', justifyContent: 'center' } },
          _react2.default.createElement(
            _Button2.default,
            {
              type: 'facebook-signin',
              onClick: handleSignInWithFacebook,
              callback: onSignedIn
            },
            labels.signinwithfacebook
          )
        ),
        _react2.default.createElement(
          'div',
          { style: { display: 'flex', justifyContent: 'center' } },
          _react2.default.createElement(
            _Button2.default,
            {
              type: 'google-signin',
              onClick: handleSignInWithGoogle,
              callback: onSignedIn
            },
            labels.signinwithgoogle
          )
        )
      );
    }
  }, props));
};

SignInModal.propTypes = {};
SignInModal.defaultProps = {
  onSignedIn: function onSignedIn() {
    return console.log('signed in');
  },
  handleCreateUserWithEmailAndPassword: function handleCreateUserWithEmailAndPassword(email, password) {
    return console.log('handleCreateUserWithEmailAndPassword', email, password);
  },
  handleSignInWithEmailAndPassword: function handleSignInWithEmailAndPassword(email, password) {
    return console.log('handleSignInWithEmailAndPassword', email, password);
  },
  handleSendPasswordResetEmail: function handleSendPasswordResetEmail(email) {
    return console.log('handleSendPasswordResetEmail', email);
  },
  handleSignInWithFacebook: function handleSignInWithFacebook() {
    return console.log('handleSignInWithFacebook');
  },
  handleSignInWithGoogle: function handleSignInWithGoogle() {
    return console.log('handleSignInWithGoogle');
  },
  labels: {
    signinwithfacebook: 'sign in with facebook',
    signinwithgoogle: 'sign in with google',
    signinform: {
      email: 'Email',
      password: 'Password',
      submit: 'Submit'
    }
  }
};

var enhance = (0, _recompose.compose)();

exports.default = enhance(SignInModal);